<!doctype style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN">

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Style sheet for slide shows (HTML version)
;; Jon Bosak 1997.08.24
;;   Note that this version assumes that the presenter will manually
;;   set fonts to 24pt (or thereabouts) in the browser used to show
;;   the slides
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(declare-flow-object-class element
  "UNREGISTERED::James Clark//Flow Object Class::element")
(declare-flow-object-class empty-element
  "UNREGISTERED::James Clark//Flow Object Class::empty-element")
(declare-flow-object-class document-type
  "UNREGISTERED::James Clark//Flow Object Class::document-type")
(declare-flow-object-class processing-instruction
  "UNREGISTERED::James Clark//Flow Object Class::processing-instruction")
(declare-flow-object-class entity
  "UNREGISTERED::James Clark//Flow Object Class::entity")
(declare-flow-object-class entity-ref
  "UNREGISTERED::James Clark//Flow Object Class::entity-ref")
(declare-flow-object-class formatting-instruction
  "UNREGISTERED::James Clark//Flow Object Class::formatting-instruction")

<![CDATA[
(define A-STAGO (make formatting-instruction data: "<A HREF='"))
(define A-STAGC (make formatting-instruction data: "'>"))
(define A-ETAG (make formatting-instruction data: "</A>"))
(define PREV (make formatting-instruction
        data: "'><IMG SRC='prev.gif' BORDER='0' ALT='[Previous]'></A>"))
(define NEXT (make formatting-instruction
        data: "'><IMG SRC='next.gif' BORDER='0' ALT=' [Next]'></A>"))
(define BR-TAG (make formatting-instruction data: "<BR>"))
]]>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; big pieces
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(element SLIDESHOW (process-children))
(element SLIDEMODULE (process-children))

(element SHOWHEAD (empty-sosofo))
(element MODHEAD (empty-sosofo))

(mode showhead-mode
  (element SHOWHEAD
      (make sequence
	    (process-children)))
  (element SHOWTITLESLIDE (empty-sosofo))
  (element SLIDEMODULE (empty-sosofo)))

(mode modhead-mode
  (element MODHEAD
      (make sequence
	    (process-children)))
  (element MODULETITLESLIDE (empty-sosofo))
  (element SLIDE (empty-sosofo)))

(element SHOWTITLESLIDE
  (make entity
	system-id: "sld00000.htm"
	(make element
	      gi: "HTML"
	      (sosofo-append
	       (make element
		     gi: "HEAD"
		     (make element
			   gi: "TITLE"
			   (with-mode showhead-mode
			      (process-node-list (ancestor "SLIDESHOW")))))
	       (make element
		     gi: "BODY"
		     attributes: (list (list "BGCOLOR" "FFFFFF"))
		     (process-children)
		     (make element
			   gi: "P"
			   (with-mode showtoc
				      (sosofo-append
				       (process-node-list
					(select-elements
					 (descendants
					  (ancestor "SLIDESHOW"))
					 "MODULETITLESLIDE"))))))))))
(mode showtoc
      (element MODULETITLESLIDE (process-children))
      (element TITLE (process-children))
      (element (MODULETITLESLIDE TITLE LINE)
	       (make sequence
		     (sosofo-append
		      A-STAGO
		      (literal (SLIDEFILE
				(ancestor-child-number "SLIDEMODULE") 0))
		      A-STAGC
		      (process-children)
		      A-ETAG
		      BR-TAG))))

(define (SLIDEFILE m n)
  (let* ((mstr (number->string m))
	 (mmstr
	  (if (< m 10)
	      (string-append "0" mstr)
	    mstr))
	 (nstr (number->string n))
	 (nnstr
	  (if (< n 10)
	      (string-append "00" nstr)
		  (if (< n 100)
		      (string-append "0" nstr)
		    nstr))))
    (string-append "sld" mmstr nnstr ".htm")))

(element MODULETITLESLIDE
  (make entity
	system-id: (SLIDEFILE (ancestor-child-number "SLIDEMODULE") 0)
	(make element
	      gi: "HTML"
	       (make element
		     gi: "HEAD"
		     (make element
			   gi: "TITLE"
			   (with-mode modhead-mode
			      (process-node-list (ancestor "SLIDEMODULE")))))
	       (make element
		     gi: "BODY"
		     attributes: (list (list "BGCOLOR" "FFFFFF"))
		     (process-children)
		     (make element
			   gi: "P"
			   (with-mode moduletoc
				      (sosofo-append
				       (process-node-list
					(select-elements
					 (descendants
					  (ancestor "SLIDEMODULE"))
					 "SLIDE")))))
		     (sosofo-append
		      A-STAGO
		      (literal "sld00000.htm")
		      PREV
		      A-STAGO
		      (literal
		       (SLIDEFILE (ancestor-child-number "SLIDEMODULE") 1))
		      NEXT)))))

(mode moduletoc
      (element SLIDE (process-children))
      (element SLIDEHEAD (process-children))
      (element (SLIDE SLIDEHEAD)
	       (make sequence
		     (sosofo-append
		      A-STAGO
		      (literal (SLIDEFILE
				(ancestor-child-number "SLIDEMODULE") 
				(ancestor-child-number "SLIDE")))
		      A-STAGC
		      (process-children)
		      A-ETAG
		      BR-TAG)))
      (element P (empty-sosofo))
      (element CODESAMPLE (empty-sosofo))
      (element BULLETLIST (empty-sosofo))
      (element BULLETSUBLIST (empty-sosofo))
      (element NUMBEREDLIST (empty-sosofo))
      (element FLATLIST (empty-sosofo))
      (element IMG (empty-sosofo))
      (element CONNECTOR (empty-sosofo)))

(element SLIDE
  (make entity
	system-id: (SLIDEFILE (ancestor-child-number "SLIDEMODULE")
			      (child-number))
	   (make element
		 gi: "HTML"
		 (sosofo-append
		  (make element
			gi: "HEAD"
			(make element
			      gi: "TITLE"
			      (with-mode modhead-mode
				 (process-node-list
				  (ancestor "SLIDEMODULE")))))
		  (make element
			gi: "BODY"
			attributes: (list (list "BGCOLOR" "FFFFFF"))
			(process-children)
			(sosofo-append
			 A-STAGO
			 (literal
			  (SLIDEFILE 
			   (ancestor-child-number "SLIDEMODULE")
			   (- (child-number) 1)))
			 PREV
			 (if (not (last-sibling?))
			     (sosofo-append
			      A-STAGO
			      (literal
			       (SLIDEFILE 
				(ancestor-child-number "SLIDEMODULE")
				(+ (child-number) 1)))
			      NEXT)
			   (sosofo-append
			    A-STAGO
			    (literal "sld00000.htm")
			    NEXT))))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; paragraphs
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(element TITLE
  (make element
	gi: "H2"))

(element SUBTITLE
  (make element
	gi: "H3"))

(element (MODULETITLESLIDE TITLE)
  (make element
	gi: "H2"
	(sosofo-append
	 A-STAGO
	 (literal "sld00000.htm")
	 PREV
	 A-STAGO
	 (literal
	  (SLIDEFILE
	   (ancestor-child-number "SLIDEMODULE") 1))
	 NEXT)
	(process-children)))

(element LINE
  (sosofo-append
   (process-children)
   (make empty-element
	 gi: "BR")))

(element SLIDEHEAD
  (make element
	gi: "H2"
	(sosofo-append
	 A-STAGO
	 (literal
	  (SLIDEFILE 
	   (ancestor-child-number "SLIDEMODULE")
	   (- (ancestor-child-number "SLIDE") 1)))
	 PREV
	 (if (not (last-sibling? (ancestor "SLIDE")))
	     (sosofo-append
	      A-STAGO
	      (literal
	       (SLIDEFILE 
		(ancestor-child-number "SLIDEMODULE")
		(+ (ancestor-child-number "SLIDE") 1)))
	      NEXT)
	   (sosofo-append
	    A-STAGO
	    (literal "sld00000.htm")
	    NEXT)))
	(process-children)))

(element CODESAMPLE
  (make element
	gi: "PRE"
	(make element
	      gi: "CODE"
	      (make element
		    gi: "B"))))

(element P
  (make element))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; lists
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(element FLATLIST
  (make element
	gi: "P"))

(element (FLATLIST ITEM)
  (make sequence
	(process-children)
	(make empty-element
	      gi: "BR")))

(element BULLETLIST
  (make element
	gi: "UL"))

(element BULLETSUBLIST
  (make element
	gi: "UL"))

(element NUMBEREDLIST
  (make element
	gi: "OL"))

(element ITEM
  (make element
	gi: "LI"))

(element (ITEM P)
  (if (= (child-number) 1)
      (make sequence)
    (make element
	  gi: "P")))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; inlines
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(element B
  (make element
	gi: "B"))

(element I
  (make element
	gi: "I"))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; graphics
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(element IMG
  (let ((align (attribute-string "align")))
    (if (and (string? align) (equal? align "CENTER"))
	(make element
	      gi: "CENTER"
	      (make element
		    gi: "IMG"
		    attributes: (list (list "SRC"
					    (attribute-string "src"))
				      (list "ALIGN"
					    (attribute-string "align")))))
      (make element
	    gi: "IMG"
	    attributes: (list (list "SRC" (attribute-string "src"))
			      (list "ALIGN" (attribute-string "align")))))))
